#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Red

extern int       ROC_Period=24;
extern int       RSI_Period=3;

extern int bars_to_calculate = 250;
extern bool flip_line_up_side_down = false;
extern double    USD = 1.0,    // weights
                    JPY = 1.0,
                    GBP = 1.0,
                    CHF = 1.0,
                    CAD = 1.0,
                    AUD = 1.0,
                    NZD = 1.0;
                    
double BIAS = 0;    // starting value for the first bar
//---- indicator buffers
double Index[];
double ROC[];
double RSIonROC[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
    string name = "";

//---- indicator line
    IndicatorShortName(name);
   IndicatorBuffers(3);
   SetIndexStyle(0,DRAW_LINE,EMPTY,EMPTY);
   SetIndexBuffer(0,RSIonROC);
   SetIndexBuffer(1,ROC);
   SetIndexBuffer(2,Index);
//----
   return(0);
}

//+------------------------------------------------------------------+
//| Calculates the relative change of symbol between bar i and i+1    |
//+------------------------------------------------------------------+
double Sentinal(string symbol, int i = 0)
{
double    a = iMA(symbol,0,1,0,0,4,i),
          b = iMA(symbol,0,1,0,0,4,(i+1)),
             move = a-b;

    if(a==0||b==0)
    {
        if(i==0)
            Print("Warning: No "+symbol+" data loaded.");
        return(0);
    }

    double moveInPercent = 100*move/b;

    return(moveInPercent);
}

//+------------------------------------------------------------------+
int start()
{
//    int iMax = Bars - 1 - IndicatorCounted();
    int iMax = Bars -1 ;

    if(iMax >= bars_to_calculate)
    {
        iMax = bars_to_calculate;
   }
   
   Index[iMax+1] = BIAS;

//----
   for(int i = iMax; i >= 0; i--)
    {
        double x = 0;

        x +=  USD * Sentinal("EURUSD",i);
        x +=  JPY * Sentinal("EURJPY",i);
        x +=  GBP * Sentinal("EURGBP",i);
        x +=  CHF * Sentinal("EURCHF",i);
        x +=  CAD * Sentinal("EURCAD",i);
        x +=  AUD * Sentinal("EURAUD",i);
        x +=  NZD * Sentinal("EURNZD",i);
        
if (flip_line_up_side_down)
      x *= -1;
                  
        Index[i] = Index[i+1]+x;
        ROC[i]=iClose(Index,0,i)-iClose(Index,0,i+ROC_Period);
    }
   for(i = iMax; i >= 0; i--) RSIonROC[i]=iRSIOnArray(ROC,Bars,RSI_Period,i);

    return(0);
}  